# nwfilter rule protocol of ipv4
type Libvirt::Nwfilter::Protocol::Ipv4 = Struct[{
    id           => Enum['ip'],
    match        => Optional[Enum['no','yes']],
    srcmacaddr   => Optional[String[1]],
    srcmacmask   => Optional[String[1]],
    dstmacaddr   => Optional[String[1]],
    dstmacmask   => Optional[String[1]],
    srcipaddr    => Optional[String[1]],
    srcipmask    => Optional[String[1]],
    dstipaddr    => Optional[String[1]],
    dstipmask    => Optional[String[1]],
    protocol     => Optional[Variant[
        Integer[0,256],
        Enum['tcp', 'udp', 'udplite', 'esp', 'ah', 'icmp', 'igmp', 'sctp'],
    ]],
    srcportstart    => Variant[Integer[0,65535],Libvirt::Nwfilter::Param, Undef],
    srcportend      => Variant[Integer[0,65535],Libvirt::Nwfilter::Param, Undef],
    dstportstart    => Variant[Integer[0,65535],Libvirt::Nwfilter::Param, Undef],
    dstportend      => Variant[Integer[0,65535],Libvirt::Nwfilter::Param, Undef],
    dscp            => Variant[Integer[0,256],Libvirt::Nwfilter::Param, Undef],
    protocolid      => Variant[Integer[0,65535],Libvirt::Nwfilter::Param, Undef],
    comment         => Optional[String[1,256]],
    connlimit-above => Variant[Integer,Libvirt::Nwfilter::Param, Undef],
}]
